// Application class header

namespace mainspring {
    using Clock = std::chrono::high_resolution_clock;
    using TimePoint = std::chrono::time_point<Clock>;
    using Duration = std::chrono::duration<double, std::ratio<1, 1>>;

    using Seconds = uint64_t;

    class Application {
    public:
        Application(const char* appName, const char* appVersion);

        void run();
    private:
        static BOOL CALLBACK mainDlgProc(HWND dlg, UINT msg, WPARAM wParam, LPARAM lParam);

        std::string getConfigPath();

        Seconds getElapsed(); // Gets the current timing session time

        void reset();
        void save(bool saveas = false);
        void open(std::string path = "");

        const char* m_appName;
        const char* m_appVersion;

        HWND m_dlg;

        // Current state of the app
        bool m_timing; // Currently timing?
        bool m_startpauseButtonPressed; // Was the start / pause button pressed?
        Seconds m_elapsedSaved; // Time saved
        TimePoint m_startTime; // When the current timing session was started
        std::string m_file; // Current time file path
        bool m_showSavedText; // Save confirmation
    };
}