// Utility implementation
#include "pch.h"
#include "utility.h"

namespace mainspring {
    bool readFile(const char* filename, std::string& out) {
        std::ifstream fileStream(filename, std::ios::binary | std::ios::ate);
        if (!fileStream.is_open())
            return false;

        size_t fileSize = fileStream.tellg();
        fileStream.seekg(0);
        out.resize(fileSize);
        fileStream.read(out.data(), fileSize);
        return true;
    }

    bool writeFile(const char* filename, const std::string& in) {
        std::string folder = filename;
        folder.resize(folder.find_last_of('\\'));
        if (!std::filesystem::exists(folder))
            std::filesystem::create_directories(folder);
        std::ofstream fileStream(filename, std::ios::binary | std::ios::trunc);
        if (!fileStream.is_open())
            return false;

        fileStream << in;
        return true;
    }
}